datablock AudioProfile(CrossbowfireSound)
{
   filename    = "./Resources/crossbowshot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CrossbowloadSound)
{
   filename    = "./Resources/crossbowload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(CrossbowImpactSound)
{
   filename    = "./Resources/crossbowhit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(ArrowTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.8 0.8 0.4";
	colors[1]     = "0.8 0.8 0.8 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;
	useInvAlpha = false;
};
datablock ParticleEmitterData(ArrowTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArrowTrailParticle";
};


datablock ParticleData(CrossbowStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(CrossbowStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CrossbowStickExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};
datablock ExplosionData(CrossbowStickExplosion)
{
   //explosionShape = "";
	soundProfile = CrossbowImpactSound;

   lifeTimeMS = 150;

   particleEmitter = CrossbowStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
};



datablock ParticleData(CrossbowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(CrossbowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CrossbowExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};
datablock ExplosionData(CrossbowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = CrossbowExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
   impulseRadius = 5;
   impulseForce = 1050;
};

AddDamageType("crossbow",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Dart> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Dart> %1',0.5,1);

datablock ProjectileData(crossbowProjectile)
{
   projectileShapeName = "./Resources/Bolt.dts";

   directDamage        = 46;
   directDamageType    = $DamageType::crossbow;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::crossbow;

   explosion             = CrossbowExplosion;
   stickExplosion        = CrossbowStickExplosion;
   bloodExplosion        = CrossbowStickExplosion;
   particleEmitter       = ArrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 175; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.1;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 170;
   velInheritFactor    = 1;

   uiName = "Crossbow Bolt";
};

datablock ItemData(crossbowItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Resources/Crossbow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Crossbow";
	iconName = "./Resources/Icon_Crossbow";
	doColorShift = true;
	colorShiftColor = "0.55 0.23 0 1.000";

	 // Dynamic properties defined by the scripts
	image = crossbowImage;
	canDrop = true;
};

datablock ShapeBaseImageData(crossbowImage)
{

   shapeFile = "./Resources/Crossbow.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 10" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = crossbowProjectile;
   projectileType = Projectile;
   melee = false;
   armReady = true;
   doColorShift = true;
   colorShiftColor = crossbowItem.colorShiftColor = "0.55 0.23 0 1.000";

   //casing = " ";


	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
	stateTransitionOnTimeout[0]	= "Reload";
	stateSequence[0]                = "Fire";
	stateSound[0]			 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]         = true;
	stateScript[1]                   = "onStopFire";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.2;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateSequence[2]                = "Reload";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateSequence[4]                 = "Ready";
	stateScript[4]                  = "onArmed";
	stateSound[4]			= CrossbowloadSound;
	stateAllowImageChange[4]	= false;

	stateName[5]                    = "Fire";
	stateTransitionOnTimeout[5]     = "Reload";
	stateTimeoutValue[5]            = 0.1;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]		= true;
	stateSound[5]			= CrossbowfireSound;

	stateName[6]			= "Reload";
	stateAllowImageChange[6]        = false;
	stateTimeoutValue[6]            = 0.3;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "Arm";
	stateTransitionOnTimeout[6]     = "StopFire";

	stateName[7]                    = "StopFire";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.5;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	//stateSequence[7]              = "Reload";
};

function crossbowImage::onArmed(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	Parent::onArmed(%this,%obj,%slot);	
}
