datablock AudioProfile(AxedrawSound)
{
   filename    = "./Resources/drawhammer.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AxeimpactSound)
{
   filename    = "./Resources/axeimpact.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(AxeExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = AxeimpactSound;

   particleEmitter = swordExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};

AddDamageType("Axe",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Axe> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Axe> %1',0.75,1);
datablock ProjectileData(AxeProjectile)
{
   directDamage        = 48;
   directDamageType  = $DamageType::Axe;
   radiusDamageType  = $DamageType::Axe;
   explosion           = AxeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ItemData(AxeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./Resources/Axe.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Hand Axe";
	iconName = "./Resources/Icon_Axe";
	doColorShift = true;
	colorShiftColor = "0.46 0.42 0.53 1.000";

	image = AxeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(AxeImage)
{
   shapeFile = "./Resources/Axe.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;
   eyeOffset = "0 0 0";
   className = "WeaponImage";
   item = AxeItem;
   ammo = " ";
   projectile = AxeProjectile;
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
   armReady = true;
   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.46 0.42 0.53 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = AxedrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "StopFire";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	
	stateName[4]                    = "StopFire";
	stateTransitionOnTimeout[4]     = "wait";
	stateTimeoutValue[4]            = 0.2;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;
	stateSequence[4]                = "StopFire";
	stateScript[4]                  = "onStopFire";

	stateName[5]                    = "wait";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateWaitForTimeout[5]		= true;


};

function AxeImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function AxeImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}