datablock AudioProfile(KatanaDrawSound)
{
   filename    = "./Resources/drawsword.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(KatanaHitSound)
{
   filename    = "./Resources/swordimpact.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(KatanaExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(KatanaExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KatanaExplosionParticle";

   uiName = "";
};

datablock ExplosionData(KatanaExplosion)
{
   lifeTimeMS = 500;
   soundProfile = KatanaHitSound;
   particleEmitter = KatanaExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;
   faceViewer     = true;
   explosionScale = "1 1 1";
   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};

AddDamageType("Katana",   '<bitmap:Add-Ons/Weapon_DefaultishWeapons/Resources/CI_Katana> %1',    '%2 <bitmap:Add-Ons/Weapon_DefaultishWeapons/Resources/CI_Katana> %1',0.75,1);
datablock ProjectileData(KatanaProjectile)
{
   directDamage        = 26;
   directDamageType  = $DamageType::Katana;
   radiusDamageType  = $DamageType::Katana;
   explosion           = KatanaExplosion;
   muzzleVelocity      = 50;
   velInheritFactor    = 1;
   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

datablock ItemData(KatanaItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./Resources/Katana.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Katana";
	iconName = "./Resources/Icon_Katana";
	doColorShift = true;
	colorShiftColor = "0.75 0.78 0.75 1.000";
	image = KatanaImage;
	canDrop = true;
};

datablock ShapeBaseImageData(KatanaImage)
{
   shapeFile = "./Resources/Katana.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;
   eyeOffset = "0 0 0";
   className = "WeaponImage";
   item = KatanaItem;
   ammo = " ";
   projectile = KatanaProjectile;
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
   armReady = true;
   doColorShift = true;
   colorShiftColor = "0.75 0.78 0.75 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = KatanaDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.1;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function KatanaImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function KatanaImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}