datablock AudioProfile(PikeDrawSound)
{
   filename    = "./Resources/drawhammer.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PikeHitSound)
{
   filename    = "./Resources/pikeimpact.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PikeswingSound)
{
   filename    = "./Resources/pikeSwing.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

//effects

datablock ParticleData(PikeExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0.0;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "1 1 1 0.9";
   colors[1]     = "1 1 1 0.9";
   sizes[0]      = 0.5;
   sizes[1]      = 0.3;
};

datablock ParticleEmitterData(PikeExplosionEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 3;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PikeExplosionParticle";

   uiName = "";
};

datablock ExplosionData(PikeExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 300;

   soundProfile = PikeHitSound;

   particleEmitter = PikeExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};


//projectile
AddDamageType("Pike",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Pike> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Pike> %1',0.75,1);
datablock ProjectileData(PikeProjectile)
{
   directDamage        = 13;
   directDamageType  = $DamageType::Pike;
   radiusDamageType  = $DamageType::Pike;
   explosion           = PikeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 1;
   lightColor  = "0 0 0.5";

   uiName = "";
};


//////////
// item //
//////////
datablock ItemData(PikeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Resources/Pike.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Pike";
	iconName = "./Resources/Icon_Pike";
	doColorShift = true;
	colorShiftColor = "0.45 0.38 0.38 1.000";

	 // Dynamic properties defined by the scripts
	image = PikeImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PikeImage)
{
   // Basic Item properties
   shapeFile = "./Resources/Pike.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PikeItem;
   ammo = " ";
   projectile = PikeProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.45 0.38 0.38 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateSequence[0]                = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]                    = PikeDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Fire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateSound[3]			 = PikeswingSound;
	stateWaitForTimeout[3]			= true;
	stateSequence[3]				= "Fire";
 	stateTransitionOnTriggerUp[3]	= "StopFire";
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";

};

function PikeImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function PikeImage::onFire(%this, %obj, %slot)
	{

	//messageAll( 'MsgClient', 'Pike prefired!!!');
	Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, rotCW);

		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec,0);
		%fY = getWord(%fvec,1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec,0);
		%eY = getWord(%evec,1);
		%eZ = getWord(%evec,2);
		
		%eXY = mSqrt(%eX*%eX+%eY*%eY);
		
		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
		
		initContainerRadiusSearch(%obj.getEyePoint(),getWord(%obj.getScale(),2)*2,$TypeMasks::ProjectileObjectType);
		while(isObject(firstWord(%searchObj = containerSearchNext())))
		{
			//If the projectile isn't in your minigame, don't reflect it
			if(!miniGameCanDamage(%searchObj,%obj))
				continue;
			
			//If the projectile has no velocity, don't reflect it
			if(vectorLen(%searchObj.getVelocity()) == 0 || %searchObj.dataBlock.lifeTime <= 0)
				continue;
			
			//If the projectile came from behind you, don't reflect it
			%vel = vectorNormalize(%searchObj.getVelocity());
			if(vectorDot(%aimVec,%vel) > 0.707)
				continue;
			
			
			//"Push" effect
			%scaleFactor = getWord(%obj.getScale(), 2);
			%data = PikeProjectile;
			%p = new Projectile()
			{
				dataBlock = %data;
				initialPosition = %pos;
				initialVelocity = %obj.getMuzzleVector(0);
				sourceObject = %obj;
				client = %obj.client;
				sourceSlot = 0;
				originPoint = %pos;
			};
			%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
			%p.explode();
			
			%searchObj.delete();
		}
		Parent::onFire(%this, %obj, %slot);
}

function PikeProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
{

parent::damage(%this, %obj, %col, %fade, %pos, %normal);

   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, 0, 0) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}