datablock AudioProfile(SlingshotFireSound)
{
   filename    = "./Resources/slingshotshoot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SlingshotHitSound)
{
   filename    = "./Resources/slingshotimpact.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SlingshotPullSound)
{
   filename    = "./Resources/slingshotpull.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(SlingshotExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = SlingshotHitSound;

   particleEmitter = CrossbowStickExplosionParticle;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
};
AddDamageType("Slingshot",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Slingshot> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Slingshot> %1',0.75,1);
datablock ProjectileData(SlingshotProjectile)
{
	uiName="";
	projectileShapeName="./Resources/Rock.dts";
   	directDamage        = 23;
   	directDamageType    = $DamageType::Slingshot;
   	radiusDamage        = 0;
   	damageRadius        = 0;
   	radiusDamageType    = $DamageType::Slingshot;
	brickExplosionRadius=3;
	brickExplosionImpact=true;
	brickExplosionForce=30;
	brickExplosionMaxVolume=1;
	brickExplosionMaxVolumeFloating=2;
	impactImpulse=60;
	muzzleVelocity=50;
	verInheritFactor=1;
   	explosion             = CrossbowExplosion;
  	stickExplosion        = SlingshotExplosion;
  	bloodExplosion        = SlingshotExplosion;
   	particleEmitter       = ArrowTrailEmitter;
	lifetime=3580;
	fadeDelay=3580;
   	armingDelay= 0;
	bounceElasticity=0.2;
	bounceFriction=0.2;
	isBallistic=true;
	gravityMod=1.0;

};

datablock ItemData(SlingshotItem)
{
	uiName="Slingshot";
	iconName="./Resources/Icon_Slingshot";
	image=Slingshotimage;
	category=Weapon;
	className=Weapon;
	shapeFile="./Resources/Slingshot.dts";
	mass=1;
	density=0.2;
	elasticity=0;
	friction=0.6;
	emap=true;
	doColorShift=true;
	colorShiftColor = "0.55 0.23 0 1.000";
	canDrop=true;
	maxAmmo = 1;
	canReload = 1;
};

datablock shapeBaseimageData(Slingshotimage)
{
	shapeFile="./Resources/Slingshot.dts";
	emap=true;
	correctMuzzleVector=true;
	className="Weaponimage";
	item=SlingshotItem;
	ammo="";
	projectile=SlingshotProjectile;
	projectileType=Projectile;
	melee=false;
	doReaction=false;
	armReady=true;
	doColorShift=true;
	colorShiftColor = "0.55 0.23 0 1.000";
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = "0 0 0";
   	rotation = eulerToMatrix( "0 0 0" );

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateSequence[1]                = "Root";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.4;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateSequence[4]                = "Arm";
	stateSound[4]			= SlingshotPullSound;
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.1;
	stateFire[5]			= true;
	stateSequence[5]		= "Fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]			= SlingshotFireSound;
};	