datablock AudioProfile(WarhammerHit)
{
   filename = "./Resources/warhammerimpact.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(WarhammerSwing)
{
   filename = "./Resources/warhammershoot.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock ParticleData(WarhammerExplosionParticle)
{
	textureName = "./Resources/jockwave";
	animateTexture = 0;
	lifetimeMS = 280;
	lifetimeVarianceMS = 0;
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	constantAcceleration = 1;
	inheritedVelFactor = 0;
	dragCoefficient = 0;
	gravityCoefficient = 0;
	windCoefficient = 0;
	framesPerSec = 1;
	useInvAlpha = 0;
	times[0] = "0";
	times[1] = "0.1";
	times[2] = "0.8";
	times[3] = "1";
	sizes[0] = "0";
	sizes[1] = "1";
	sizes[2] = "8";
	sizes[3] = "11";
	colors[0] = "1 1 1 0";
	colors[1] = "1 1 1 1";
	colors[2] = "1 1 1 1";
	colors[3] = "1 1 1 0";
};
datablock ParticleEmitterData(WarhammerExplosionEmitter)
{
	particles = WarhammerExplosionParticle;
	uiName = "";
	lifetimeMS = 0;
	lifetimeVarianceMS = 0;
	ejectionOffset = 0;
	ejectionPeriodMS = 1000;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	orientParticles = 0;
	orientOnVelocity = 0;
	phiReferenceVel = 0;
	phiVariance = 0;
	thetaMin = 0;
	thetaMax = 0;
	useEmitterColors = 0;
	useEmitterSizes = 0;
};
datablock ExplosionData(WarhammerExplosion)
{
	lifeTimeMS = 400;
	radiusDamage = 38;
	damageRadius = 4;
	soundProfile = WarhammerHit;
	particleEmitter = WarhammerExplosionEmitter;
	particleDensity = 1;
	particleRadius = 0;
	faceViewer = true;
	explosionScale = "1 1 1";
	shakeCamera = true;
	camShakeFreq = "80 80 100";
	camShakeAmp = "8 8 8";
	camShakeDuration = 0.6;
	camShakeRadius = 15;
	lightStartRadius = 0;
	lightEndRadius = 4;
	lightStartColor = "0.8 0.8 0.5";
	lightEndColor = "0.4 0.4 0.4";
};
AddDamageType("Warhammer",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Warhammer> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Warhammer> %1',0.75,1);
AddDamageType("WarhammerRadius",   '<bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Warhammer> %1',    '%2 <bitmap:add-ons/Weapon_DefaultishWeapons/Resources/CI_Warhammer> %1',0.75,1);

datablock ProjectileData(WarhammerProjectileData)
{
	uiName = "";
	lifetime = 281;
	fadeDelay = 0;
	explosion = WarhammerExplosion;
	directDamage = 30;
	directDamageType = $DamageType::Warhammer;
	radiusDamageType = $DamageType::WarhammerRadius;
	impactImpulse = 980;
	verticalImpulse = 100;
	brickExplosionRadius = 4;
	brickExplosionImpact = true;
	brickExplosionForce = 10;
	brickExplosionMaxVolume = 32;
	brickExplosionMaxVolumeFloating = 48;
 	muzzleVelocity = 50;
	velInheritFactor = 1;
	isBallistic = false;
	gravityMod = 0;
	hasLight = false;	
	armingDelay = 0;
	bounceElasticity = 0;
	bounceFriction = 0;
};
datablock ItemData(WarhammerItem)
{
	category = "Weapon";
	className = "Weapon";
	uiName = "Warhammer";
	shapeFile = "./Resources/Warhammer.dts";
	iconName = "./Resources/Icon_Warhammer";
	canDrop = true;
	image = WarhammerImage;
	friction = 0.5;
	elasticity = 0.1;
	sticky = 0;
	gravityMod = true;
	mass = 10;
	drag = 0.7;
	density = 3.0;
	doColorShift = true;
	colorShiftColor = "0.87 0.87 0.87 1.000";
};
datablock ShapeBaseImageData(WarhammerImage)
{
	className = "WeaponImage";
	shapeFile = "./Resources/Warhammer.dts";
	Projectile = WarhammerProjectileData;
	projectileType = Projectile;
	emap = true;
	Item = WarhammerItem;
	armReady = true;
	melee = true;
	mountPoint = 0;
	correctMuzzleVector = false;
	offset = "0 0 0";
	eyeOffset = "0 0 0";
	doColorShift = true;
	colorShiftColor = WarhammerItem.colorShiftColor = "0.87 0.87 0.87 1.000";
	
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			= RPGHammerDrawSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateAllowImageChange[1]        = true;

	stateName[2]		        = "PreFire";
	stateScript[2]		        = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]	        = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]		        = "Fire";
	stateTransitionOnTimeout[3]     = "StopFire";
	stateTimeoutValue[3]	        = 0.08;
	stateFire[3]		        = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]	        = "Fire";
	stateScript[3]		        = "onFire";
	stateWaitForTimeout[3]	        = true;
	stateSound[3]		        = WarhammerSwing;

	stateName[5]		        = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]	        = 0.82;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]	        = true;
	stateSequence[5]	        = "StopFire";
	stateScript[5]		        = "onStopFire";
};
function WarhammerImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, ShiftDown);
}
function WarhammerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}